AWSTemplateFormatVersion: 2010-09-09
Description: >-
  AWS CloudFormation S3 to store the source code
Resources:
  MyLambda:
    Type: AWS::Lambda::Function
    Properties:
      Code:
        S3Bucket: # TODO
        S3Key: # TODO
      Runtime: nodejs12.x
      Tags:
        MyFirstLambda: true
      Hanlder: handler.handler
      FunctionName: My-Lambda
      Role:
        Fn:GetAtt:
          - MyLamdbaRole
          - Arn
  MyLamdbaRole:
    Type: AWS::IAM::Role
    Properties:
      RoleName: My-Lambda-Role
      # ??? WTF ???
      AssumeRolePolicyDocument:
        Statement:
          - Action: sts:AssumeRole
            Effect: Allow
            Principal:
              Service: lambda.amazonaws.com
      Policies:
        # Est-il possible d'utiliser directement un role
        - PolicyName: AccessPolicy
          PolicyDocument:
            Statement:
              - Effect: Allow
                Action:
                  - s3:GetBucketPolicy
                  - s3:PutObject
                  - s3:GetObject
                # Pourquoi ne peut-on pas définir un role sans l'associer à une resource ?
                Resource:
                  - Fn:GetAtt:
                      - MyLamdbaRole
                      - Arn
